// Bismilliyahi Rohmanir Rohim!
// In the name of Allah the Most Gracious,
// The Most Merciful.
// We're nothing and you're everything.
#include <fstream>
#include <bits/stdc++.h>
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math,O3")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,avx,mmx,tune=native")
// #include <ext/pb_ds/detail/standard_policies.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
using namespace std;
// using namespace __gnu_pbds;
// typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;
/* find_by_order() order_of_key() */
void __print(int x) {cerr << x;}
void __print(long x) {cerr << x;}
void __print(long long x) {cerr << x;}
void __print(unsigned x) {cerr << x;}
void __print(unsigned long x) {cerr << x;}
void __print(unsigned long long x) {cerr << x;}
void __print(float x) {cerr << x;}
void __print(double x) {cerr << x;}
void __print(long double x) {cerr << x;}
void __print(char x) {cerr << '\'' << x << '\'';}
void __print(const char *x) {cerr << '\"' << x << '\"';}
void __print(const string &x) {cerr << '\"' << x << '\"';}
void __print(bool x) {cerr << (x ? "true" : "false");}
 
template<typename T, typename V>
void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ", "; __print(x.second); cerr << '}';}
template<typename T>
void __print(const T &x) {int f = 0; cerr << '{'; for (auto &i: x) cerr << (f++ ? ", " : ""), __print(i); cerr << "}";}
void _print() {cerr << "]\n";}
template <typename T, typename... V>
void _print(T t, V... v) {__print(t); if (sizeof...(v)) cerr << ", "; _print(v...);}
#ifdef DEBUG
#define dbg(x...) cerr << "\e[91m"<<__func__<<":"<<__LINE__<<" [" << #x << "] = ["; _print(x); cerr << "\e[39m" << endl;
#else
#define dbg(x...)
#endif
#define elif else if
#define pb push_back
#define fast cin.tie(nullptr); ios_base::sync_with_stdio(false);
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define str to_string 
#define sz(x) int(x.size())
#define F first 
#define S second
#define FOR(i, a, b) for (int i=a; i<(b); i++)
#define F0R(i, a) for (int i=0; i<(a); i++)
#define FORd(i,a,b) for (int i = (b)-1; i >= a; i--)
#define F0Rd(i,a) for (int i = (a)-1; i >= 0; i--)
#define watch(x) cout << #x << " <----  " << x << endl
mt19937 rng (chrono::steady_clock::now().time_since_epoch().count());
using ll = long long;
using ld = long double;
using ull = unsigned long long;
const int N = 1e5 + 1;
const ll mod = 1e9 + 7;
const int INF = 1e9;
ll n, m, k, q;
int h1[4] = {1,0,0,-1};
int h2[4] = {0,-1,1,0};
ll binpow(ll a, ll b){
    if(b == 0) return 1;
    if(b % 2) return (a % mod * binpow(a, b - 1)% mod) % mod;
    else return (binpow(a, b / 2) % mod * binpow(a, b / 2) % mod) % mod;
}
ll model(ll a, ll b){
    // (a % MOD * b^(MOD - 2) % MOD) % MOD;
    return (a % mod * binpow(b, (mod - 2)) % mod) % mod;
}
ll a[N];
bool check(int x, int y){
    return (x >= 0 && y >= 0 && x < n && y < m);
}
int go(char c){
    return c - '0';
}
vector<ll> adj[N];
ll dp[N + 1];
ll p[N + 1];
void solve(){
    // #ifndef ONLINE_JUDGE
    //     freopen("input.txt", "r", stdin);
    //     freopen("output.txt", "w", stdout);
    //     freopen("errors.txt", "w", stderr);
    // #endif
    int n;
    cin >> n;
    int k = 0;
    int cur = 1;
    while(cur * 2 <= n + 1){
        k++;
        cur *= 2;
    }
    map<int, int> mp;
    for(int i = 0; i < n; i++){
        cin >> a[i];
        mp[a[i]]++;
    }
    
    int mn = *min_element(a, a + n);
    if(mp[mn] != k){
        cout << "-1";
    }
    else{
        for(int i = 0; i < n; i++){
            if(mp[a[i]] >= k && a[i] != mn){
                cout << -1;
                return;
            }
        }
        set <int> s;
        for(int i = 0; i < n; i++){
            s.insert(a[i]);
        }
        if(sz(s) != k + 1){
            cout << -1;
            return;
        }
        cur = 0;
        for(int i : s){
            ++cur;
            if(cur == k + 1){
                cout << i;
            }
            else cout << i << ' ';
        }
    }
}

/*Give me some sunshine, give me some rain, its a beatifull day-ay-ay-ay...*/
int32_t main(){
    fast
    int tt = 1;
    // cin >> tt;
    while(tt--){
        solve();
    }
}
